/// <reference path=".config/sa.d.ts" />
/// <reference no-default-lib="true" />

var VK_F5 = 116;
const VK_RMB = 2;
const VEC_COEF = 100;
var player = new Player(0);
var player_char = player.getChar();
var target_handle = 0;
var last_target_handle = -1;
var TextID = 1;
var aim_time = 0;
var pedTypes = [155, 147, 167, 205, 17];
var pedCooldowns = [];
var cooldownTime = 0;


while (true) {
  wait(50)
  cooldown();
  // if (Pad.IsKeyPressed(VK_F5)) {
  //   Text.UseCommands(false);
  //   player.clearWantedLevel()
  //   pedCooldowns = [];
  //   last_target_handle = -1;
  //   Clock.SetTimeOfDay(12, 0);
  // }
  if (Pad.IsKeyPressed(VK_RMB) || player.isTargettingAnything()) {
    var player_pos = player_char.getCoordinates();    
    for (var tmp_handle = 0; tmp_handle < 35584; tmp_handle++) {
      if (isCharOk(tmp_handle)) {
          if (!Char.DoesExist(target_handle) || Char.IsDead(target_handle)) {
              target_handle = tmp_handle;
          }
          target_handle = getClosest(target_handle, tmp_handle);
      }
      //tmp_handle update
      if (tmp_handle % 256 >= 128) {
          tmp_handle += 127;
      }
      if (tmp_handle % 10000 == 1) {
          wait(1);
      }
    }
    var char_handle = new Char(target_handle)
    for (var i = 0; i < pedTypes.length; i++) {
      if (char_handle.isModel(pedTypes[i])) {
        if (!(pedCooldowns.indexOf(pedTypes[i]) >= 0)) {
          playGiveCashAnim(target_handle)
          if (last_target_handle != target_handle) {
            aim_time = Clock.GetTimeOfDay().minutes
            createTextDraw("You are robbing the store, hold aim until the clerk has given their money", 320, 420, 1, 1.2, true, 255, 255, 255, 255, true)
          }
          rob(pedTypes[i])
          last_target_handle = target_handle
        } else {
          if (!(char_handle.hasGotWeapon(25))) {
            playScaredAnim(target_handle)
            player.alterWantedLevel(1)
          } else {
            player.alterWantedLevel(2)
          }
        }
      }
    }
  }
}

function getRandomArbitrary(min, max) {
  return Math.RandomIntInRange(min, max)
}

function rob (skin) {
  // wait(5000)
  var char_handle = new Char(target_handle)
  var player_p = player_char.getCoordinates();
  if (Clock.GetTimeOfDay().minutes == aim_time + 3) {
    var money = getRandomArbitrary(115, 850)
    if (clerkHasWeapon()) {
      char_handle.giveWeapon(25, 30)
      Task.KillCharOnFoot(char_handle, player_char)
      createHelpText("You have robbed $" + money + " from the store, but the clerk decided to fight back.")
    } else {
      createHelpText("You have robbed $" + money + " from the store")
    }
    Text.UseCommands(false);
    Pickup.CreateMoney(player_p.x, player_p.y, player_p.z, money, false)
    player.alterWantedLevel(1)
    aim_time = 0;
    pedCooldowns.push(skin)
    target_handle = 0;
    cooldownTime = Clock.GetTimeOfDay().minutes
  }
}

function clerkHasWeapon () {
  var generateNumber = getRandomArbitrary(0, 5);
  if (generateNumber > 2) {
    return true
  } else {
    return false
  }
}

function cooldown() {
  if (Clock.GetTimeOfDay().minutes == cooldownTime + 120) {
    pedCooldowns = []
  }
}

function isCharOk(char_handle) {
  var tmpchar = new Char(char_handle);
  if (Number(player_char) == char_handle || 
  !Char.DoesExist(char_handle) || 
  Char.IsDead(char_handle) ||
  tmpchar.isInAnyCar() ||
  tmpchar.isInAnyHeli() ||
  tmpchar.isInAnyPlane() ||
  tmpchar.isInAnyTrain()
  ) {
      return false;
  }
  return true;
}

function createHelpText(text) {
  FxtStore.insert("MH" + TextID, text);
  Text.PrintHelp("MH" + TextID);
  TextID++;
}

function createTextDraw(text, x, y, font, scale, shadow, r, g, b, a, center) {

  Text.SetFont(font);
  Text.SetScale(3000, scale);

  Text.SetEdge(shadow ? 5 : 0, 0, 0, 0, 255);
  
  Text.SetColor(r, g, b, a);
  Text.SetWrapX(3000);
  if(center) {
      Text.SetCenter(center);
  }

  FxtStore.insert("MH" + TextID, text);
  Text.DisplayWithNumber(x, y, "MH" + TextID, 3);
  TextID++;
}

function playGiveCashAnim (char) {
  var char_handle = new Char(char)
  Streaming.RequestAnimation("SHOP");
  while (!Streaming.HasAnimationLoaded("SHOP")) {
    wait(1);
  }
  Task.PlayAnimNonInterruptable(char_handle,"SHP_Rob_GiveCash","SHOP",4.0,0,0,0,0,1000);
  wait(1);
}

function playScaredAnim (char) {
  var char_handle = new Char(char)
  Streaming.RequestAnimation("ON_LOOKERS");
  while (!Streaming.HasAnimationLoaded("ON_LOOKERS")) {
    wait(1);
  }
  Task.PlayAnimNonInterruptable(char_handle,"panic_hide","ON_LOOKERS",4.0,0,0,0,0,1000);
  wait(1);
}

function getClosest(char_handle_a, char_handle_b) {
  if (!Char.DoesExist(char_handle_a) || !Char.DoesExist(char_handle_b)) {
      return undefined;
  }
  var char_a = new Char(char_handle_a);
  var char_b = new Char(char_handle_b);
  var ap = char_a.getCoordinates();
  var bp = char_b.getCoordinates();
  var cp = Camera.GetActiveCoordinates();
  var cpat = Camera.GetActivePointAt();
  var player_p = player_char.getCoordinates();
  var far = {
      x:player_p.x + VEC_COEF*(cpat.x - cp.x), 
      y:player_p.y + VEC_COEF*(cpat.y - cp.y), 
      z:player_p.z + VEC_COEF*(cpat.z - cp.z)
  };
  var dist_a = Math.GetDistanceBetweenCoords3D(ap.x,ap.y,ap.z,far.x,far.y,far.z) + Math.GetDistanceBetweenCoords3D(ap.x,ap.y,ap.z,player_p.x,player_p.y,player_p.z);
  var dist_b = Math.GetDistanceBetweenCoords3D(bp.x,bp.y,bp.z,far.x,far.y,far.z) + Math.GetDistanceBetweenCoords3D(bp.x,bp.y,bp.z,player_p.x,player_p.y,player_p.z);
  
  return (dist_a < dist_b) ? char_handle_a : char_handle_b;
}